using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace DatPacker {
	class Program {
		private struct struct_files {
			public String relName;
			public String absName;
		}
		static int Main(string[] args) {
			/*args = new string[2];
			args[0] = "define.txt";
			args[1] = "output.dat";*/
			if (args.Length != 2) {
				Console.WriteLine("Usage: DatPacker.exe definition.txt output.dat\n");
				return 0;
			}

			String fileinput = args[0];
			String fileoutput = args[1];
			String line;
			Queue files = new Queue();

			StreamReader reader = File.OpenText(fileinput);
			while ((line = reader.ReadLine()) != null)
			{
				line = line.Trim();
				if (line.Length==0) continue;
				
				String[] aTmp = line.Split(" \t".ToCharArray());
				struct_files item;
				item.relName = aTmp[0].Replace("\\", "/");
				item.absName = aTmp[1];

				files.Enqueue(item);
			}
			reader.Close();

			uint items = (uint) files.Count;
			FileStream fs = new System.IO.FileStream(fileoutput, System.IO.FileMode.Create, System.IO.FileAccess.Write);
			BinaryWriter bw = new BinaryWriter(fs);
			//hlavicka
			bw.Write(new byte[] {0x89, 0x44,0x41,0x54, 0x0D, 0x0A, 0x31, 0x2E, 0x30, 0x1A, 0x0A});
			bw.Write(items);
			while(files.Count > 0) {
				struct_files item = (struct_files) files.Dequeue();
				bw.Write((byte) item.relName.Length);
				bw.Write(item.relName.ToCharArray());

				FileStream fsin = new System.IO.FileStream(item.absName, System.IO.FileMode.Open, System.IO.FileAccess.Read);
				BinaryReader br = new BinaryReader(fsin);
				byte[] data = new byte[fsin.Length];
				br.Read(data, 0, (int) fsin.Length);
				bw.Write((uint) fsin.Length);
				bw.Write(data);
				br.Close();
				fsin.Close();
			}
			bw.Close();
			fs.Close();
			return 0;
		}
	}
}
